unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;
  filename, filename2, textbuf, outbuf : string;
  filein, fileout :textfile;
  i, k: longword;
  tmp: tstringarray;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    filename := '';
    filename := OpenDialog1.Filename;
  end;
  if filename='' then exit;
  filename2:= copy(filename, -3, length(filename)-3)+'csv';
  //ShowMessage(filename+slinebreak+filename2);

  assignfile(filein, filename);
  assignfile(fileout, filename2);

  try
    reset(filein);
    rewrite(fileout);
    i := 0;
    while not eof(filein) do
      begin
        readln(filein, textbuf);
        if textbuf <> '' then begin
           tmp := textbuf.trim.split('=');
           if tmp[0] = 'b0' then outbuf := '';
           outbuf := outbuf + tmp[1].TrimRight;
           if tmp[0] = 'b2' then outbuf := outbuf + '1,';
           if tmp[0] = 'a2' then begin
              writeln(fileout, outbuf);
              i := i + 1;
           end;
        end;
      end;
  finally
     closefile(filein);
     closefile(fileout);
     //showmessage('Done.');
     memo1.append('Converting file: ' + filename + sLineBreak + '... to file: ' + filename2);
     if i = 0 then begin
        memo1.append('No biquads found.' + sLineBreak);
        try
          deletefile(filename2);
        except
        end;
     end else begin
        memo1.append('Found ' + i.tostring + ' biquads. Conversion done.' + sLineBreak);
     end;
  end;

end;

end.

